## org.eclipse.xsd.impl
Class XSDConcreteComponentImpl

    java.lang.Object
      org.eclipse.emf.common.notify.impl.BasicNotifierImpl
          org.eclipse.emf.ecore.impl.BasicEObjectImpl
              org.eclipse.emf.ecore.impl.EObjectImpl
                  org.eclipse.xsd.impl.XSDConcreteComponentImpl

All Implemented Interfaces:
  Notifier, EObject, InternalEObject, XSDConcreteComponent

Direct Known Subclasses:
  XSDAttributeGroupContentImpl, XSDComponentImpl, XSDDiagnosticImpl, XSDParticleContentImpl, XSDSchemaContentImpl

    public abstract class XSDConcreteComponentImpl

extends EObjectImpl
implements XSDConcreteComponent

An implementation of the model object 'Concrete Component'.

The following features are implemented:

- `Element`
- `Container`
- `Root Container`
- `Schema`
- `Diagnostics`

Nested Class Summary
`static class` `XSDConcreteComponentImpl.XSDContentsEList`

Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`BasicEObjectImpl.EPropertiesHolder, BasicEObjectImpl.EPropertiesHolderBaseImpl, BasicEObjectImpl.EPropertiesHolderImpl`

Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`BasicNotifierImpl.EAdapterList<E extends java.lang.Object & Adapter>`

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject
`InternalEObject.EStore`

Field Summary
`protected int` `ANALYZED`
`protected int` `ANALYZING`
`protected int` `CIRCULAR`
`protected EList<XSDDiagnostic>` `diagnostics` The cached value of the '`Diagnostics`' containment reference list
`protected org.w3c.dom.Element` `element` The cached value of the '`Element`' attribute
`protected static org.w3c.dom.Element` `ELEMENT_EDEFAULT` The default value of the '`Element`' attribute
`protected static int` `ERROR`
`protected static int` `FATAL`
`protected boolean` `forceResolve`
`protected static int` `INFORMATION`
`protected boolean` `isReconciling`
`protected int` `UNANALYZED`
`protected boolean` `updatingDOM`
`protected static int` `WARNING`
`protected EList<XSDConcreteComponent>` `xsdContents`

Fields inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eContainer, eContainerFeatureID, EDELIVER, EDYNAMIC_CLASS, eFlags, ELAST_EOBJECT_FLAG, ELAST_NOTIFIER_FLAG, eProperties, EPROXY`

Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl
`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

Fields inherited from interface org.eclipse.emf.ecore.InternalEObject
`EOPPOSITE_FEATURE_BASE`

Constructor Summary
`protected` `XSDConcreteComponentImpl()`

Method Summary
`protected void` `adoptBy(XSDSchema xsdSchema)`
`protected void` `adoptContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected void` `adoptDiagnostic(XSDDiagnostic xsdDiagnostic)`
`protected boolean` `analyze()`
`protected void` `changeAttribute(EAttribute eAttribute)`
`protected void` `changeReference(EReference eReference)`
`protected java.util.Collection<XSDDiagnostic>` `checkAttributes(java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String[] allowedAttributeNames)`
`protected XSDDiagnostic` `checkAttributeTypeConstraint(java.lang.String builtInTypeName, java.lang.String builtInAttributeName, java.lang.String value, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName, boolean isRequired)`
`protected XSDDiagnostic` `checkAttributeTypeConstraint(XSDComplexTypeDefinition xsdComplexTypeDefinition, java.lang.String builtInAttributeName, java.lang.String value, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName, boolean isRequired)`
`protected XSDDiagnostic` `checkBuiltInTypeConstraint(java.lang.String builtInTypeName, java.lang.String value, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName, boolean isRequired)`
`protected XSDDiagnostic` `checkComplexContent(java.lang.String builtInTypeName, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element)`
`protected XSDDiagnostic` `checkComplexContent(XSDComplexTypeDefinition xsdComplexTypeDefinition, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element)`
`protected XSDDiagnostic` `checkElementComplexContent(java.lang.String elementName, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element)`
`protected XSDDiagnostic` `checkSimpleTypeConstraint(XSDSimpleTypeDefinition xsdTypeDefinition, java.lang.String value, java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName, boolean isRequired)`
`void` `clearDiagnostics()` Clears any `diagnostics` associated with the component and all those it contains.
`XSDConcreteComponent` `cloneConcreteComponent(boolean deep, boolean shareDOM)` Creates a clone of the component.

`protected static

`<T extends XSDConcreteComponent> java.util.List<T>`

`

`cloneConcreteComponents(java.util.List<T> xsdConcreteComponents, boolean deep, boolean shareDOM)`

`protected boolean` `considerAllContainsForBestConcreteComponent()`
`boolean` `contains(XSDConcreteComponent xsdConcreteComponent)` Returns whether the given component is contained by this component.
`protected boolean` `convertToBoolean(java.lang.String value)`
`protected XSDDiagnostic` `createDiagnostic(XSDDiagnosticSeverity severity, java.lang.String key)`
`protected XSDDiagnostic` `createDiagnostic(XSDDiagnosticSeverity severity, java.lang.String key, java.lang.Object s1)`
`protected XSDDiagnostic` `createDiagnostic(XSDDiagnosticSeverity severity, java.lang.String key, java.lang.Object s1, java.lang.Object s2)`
`protected XSDDiagnostic` `createDiagnostic(XSDDiagnosticSeverity severity, java.lang.String key, java.lang.Object s1, java.lang.Object s2, java.lang.Object s3)`
`org.w3c.dom.Element` `createElement()`
`protected org.w3c.dom.Element` `createElement(int nodeType)`
`protected XSDDiagnostic` `createRequiredAttributeDiagnostic(java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName)`
`protected XSDAttributeDeclaration` `createUnresolvedAttributeDeclaration(java.lang.String namespace, java.lang.String localName)`
`protected XSDAttributeGroupDefinition` `createUnresolvedAttributeGroupDefinition(java.lang.String namespace, java.lang.String localName)`
`protected XSDComplexTypeDefinition` `createUnresolvedComplexTypeDefinition(java.lang.String namespace, java.lang.String localName)`
`protected XSDElementDeclaration` `createUnresolvedElementDeclaration(java.lang.String namespace, java.lang.String localName)`
`protected XSDIdentityConstraintDefinition` `createUnresolvedIdentityConstraintDefinition(java.lang.String namespace, java.lang.String localName)`
`protected XSDModelGroupDefinition` `createUnresolvedModelGroupDefinition(java.lang.String namespace, java.lang.String localName)`
`protected XSDNotationDeclaration` `createUnresolvedNotationDeclaration(java.lang.String namespace, java.lang.String localName)`
`protected XSDSimpleTypeDefinition` `createUnresolvedSimpleTypeDefinition(java.lang.String namespace, java.lang.String localName)`
`protected XSDTypeDefinition` `createUnresolvedTypeDefinition(java.lang.String namespace, java.lang.String localName)`
`java.lang.Object` `eGet(int featureID, boolean resolve, boolean coreType)`
`NotificationChain` `eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)`
`boolean` `eIsSet(int featureID)`
`void` `elementAttributesChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed attributes; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`.
`void` `elementChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`.
`void` `elementContentsChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed contents; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`.
`boolean` `eNotificationRequired()`
`void` `eNotify(Notification msg)`
`EObject` `eObjectForURIFragmentSegment(java.lang.String uriFragmentSegment)`
`void` `eSet(int featureID, java.lang.Object newValue)`
`protected EClass` `eStaticClass()`
`void` `eUnset(int featureID)`
`java.lang.String` `eURIFragmentSegment(EStructuralFeature eStructuralFeature, EObject eObject)`
`void` `forceEngulf(org.w3c.dom.Element newElement, org.w3c.dom.Element engulfingElement, org.w3c.dom.Element referenceElement, org.w3c.dom.Node referenceChild)`
`void` `forceEngulf(org.w3c.dom.Node firstAdoptee, org.w3c.dom.Element engulfingElement, org.w3c.dom.Node referenceChild)`
`void` `forceNiceInsertBefore(org.w3c.dom.Node parent, org.w3c.dom.Node newChild, org.w3c.dom.Node referenceChild)`
`void` `forceNiceRemoveChild(org.w3c.dom.Node parent, org.w3c.dom.Node child)`
`void` `forceReplace(org.w3c.dom.Element replacementElement, org.w3c.dom.Element referenceElement)`
`protected org.w3c.dom.Node` `getAdoptionParentNode(EReference eReference)`
`XSDConcreteComponent` `getBestConcreteComponent(java.util.List<org.w3c.dom.Element> elementPath)`
`java.util.Collection<XSDConcreteComponent>` `getComponentsWithApplicationInformation(java.lang.String sourceURI)` Returns the collection of components that have an `annotation` containing an `appinfo` with given source URI.
`protected void` `getComponentsWithInformation(java.util.Collection<XSDConcreteComponent> result, int nodeType, java.lang.String sourceURI)`
`java.util.Collection<XSDConcreteComponent>` `getComponentsWithUserInformation(java.lang.String sourceURI)` Returns the collection of components that have an `annotation` containing a `documentation` with given source URI.
`XSDConcreteComponent` `getContainer()` Returns the value of the 'Container' reference
`protected java.util.Collection<org.w3c.dom.Element>` `getContentNodes(org.w3c.dom.Element changedElement)`
`EList<XSDDiagnostic>` `getDiagnostics()`
`protected XSDConcreteComponentImpl` `getDiagnosticTarget(XSDConcreteComponent xsdConcreteComponent)`
`org.w3c.dom.Element` `getElement()`
`XSDConcreteComponent` `getRootContainer()` Returns the value of the 'Root Container' reference
`XSDSchema` `getSchema()` Returns the value of the 'Schema' reference
`protected java.lang.String` `getURIReferenceLabel()`
`protected EList<XSDConcreteComponentImpl>` `getXSDConcreteComponentImpls()`
`EList<XSDConcreteComponent>` `getXSDContents()`
`protected XSDFactory` `getXSDFactory()`
`protected XSDPackage` `getXSDPackage()`
`protected void` `handleAnnotationReconciliation(EReference eReference, java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`protected void` `handleElementForAdopt(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected void` `handleReconciliation(java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`protected void` `handleUnreconciledElement(org.w3c.dom.Element child, java.util.List<XSDConcreteComponent> newContents, java.util.List<XSDConcreteComponent> remainingContents)`
`protected boolean` `isUpdatingDOM()`
`void` `moveContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected java.lang.String` `niceCreateNamespaceAttribute(java.lang.String namespace)`
`void` `niceInsertBefore(org.w3c.dom.Node parent, org.w3c.dom.Node newChild, org.w3c.dom.Node referenceChild)`
`void` `niceRemoveChild(org.w3c.dom.Node parent, org.w3c.dom.Node child)`
`protected void` `niceSetAttribute(org.w3c.dom.Element element, java.lang.String attribute, java.lang.String value)`
`protected void` `niceSetAttributeURIValue(org.w3c.dom.Element element, java.lang.String attribute, java.lang.String uriList)`
`protected void` `orphanBy(XSDSchema xsdSchema)`
`protected void` `orphanContent(EReference eReference, XSDConcreteComponent xsdConcreteComponent)`
`protected void` `orphanDiagnostic(XSDDiagnostic xsdDiagnostic)`
`protected void` `patch()`
`protected static java.lang.String` `populateDiagnostic(XSDDiagnostic xsdDiagnostic, java.lang.String key, java.lang.Object[] substitutions)`
`protected void` `printDFA(XSDParticle.DFA dfa)`
`protected void` `reconcile(org.w3c.dom.Element changedElement)`
`protected void` `reconcileAttributes(org.w3c.dom.Element changedElement)`
`protected void` `reconcileContents(org.w3c.dom.Element changedElement)`
`protected XSDDiagnostic` `reportConstraintViolation(java.lang.String part, java.lang.String anchor, org.w3c.dom.Element element, java.lang.String attributeName, java.lang.Object[] substitutions)`
`void` `reset()`
`XSDAttributeDeclaration` `resolveAttributeDeclaration(java.lang.String localName)` Returns the resolved attribute declaration of the given `name` within the `schema`.
`XSDAttributeDeclaration` `resolveAttributeDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute declaration of the given `namespace` and `name`.
`XSDAttributeDeclaration` `resolveAttributeDeclarationURI(java.lang.String uri)` Returns the resolved attribute declaration of the given `URI`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinition(java.lang.String localName)` Returns the resolved attribute group definition of the given `name` within the `schema`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute group definition the given `namespace` and `name`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinitionURI(java.lang.String uri)` Returns the resolved attribute group definition of the given `URI`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinition(java.lang.String localName)` Returns the resolved complex type definition of the given `name` within the `schema`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved complex type definition of the given `namespace` and `name`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinitionURI(java.lang.String uri)` Returns the resolved complex type definition of the given `URI`.
`XSDElementDeclaration` `resolveElementDeclaration(java.lang.String localName)` Returns the resolved element declaration of the given `name` within the `schema`.
`XSDElementDeclaration` `resolveElementDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved element declaration of the given `namespace` and `name`.
`XSDElementDeclaration` `resolveElementDeclarationURI(java.lang.String uri)` Returns the resolved element declaration of the given `URI`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinition(java.lang.String localName)` Returns the resolved identity constraint definition of the given `name` within the `schema`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved identity constraint definition of the given `namespace` and `name`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinitionURI(java.lang.String uri)` Returns the resolved identity constraint definition of the given `URI`.
`XSDModelGroupDefinition` `resolveModelGroupDefinition(java.lang.String localName)` Returns the resolved model group definition of the given `name` within the `schema`.
`XSDModelGroupDefinition` `resolveModelGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved model group definition of the given `namespace` and `name`.
`XSDModelGroupDefinition` `resolveModelGroupDefinitionURI(java.lang.String uri)` Returns the resolved model group definition of the given `URI`.
`XSDNotationDeclaration` `resolveNotationDeclaration(java.lang.String localName)` Returns the resolved notation declaration the given `name` within the `schema`.
`XSDNotationDeclaration` `resolveNotationDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved notation declaration of the given `namespace` and `name`.
`XSDNotationDeclaration` `resolveNotationDeclarationURI(java.lang.String uri)` Returns the resolved notation declaration of the given `URI`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinition(java.lang.String localName)` Returns the resolved simple type definition of the given `name` within the `schema`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved simple type definition of the given `namespace` and `name`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinitionURI(java.lang.String uri)` Returns the resolved simple type definition of the given `URI`.
`XSDTypeDefinition` `resolveTypeDefinition(java.lang.String localName)` Returns the resolved type definition of the given `name` within the `schema`.
`XSDTypeDefinition` `resolveTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved type definition of the given `namespace` and `name`.
`XSDTypeDefinition` `resolveTypeDefinitionURI(java.lang.String uri)` Returns the resolved type definition of the given `URI`.
`void` `setElement(org.w3c.dom.Element element)` Sets the value of the '`Element`' attribute
`void` `setElementGen(org.w3c.dom.Element newElement)`

`static

`<T> void`

`

`setListContentAndOrder(EList<T> targetList, java.util.List<? extends T> prototypeList)`

`java.lang.String` `toString()`
`protected void` `traverseToRootForAnalysis()`
`protected void` `traverseToRootForPatching()`
`void` `updateElement()` Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.
`void` `updateElement(boolean deep)` Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.
`protected void` `updatePrefix(org.w3c.dom.Node node, java.lang.String namespace, java.lang.String oldPrefix, java.lang.String newPrefix)`
`void` `validate()` Validates whether this component conforms to the constraints defined in the XML Schema standard.

Methods inherited from class org.eclipse.emf.ecore.impl.EObjectImpl
`eAdapters, eBasicAdapters, eBasicProperties, eBasicSetContainer, eClass, eContainerFeatureID, eDeliver, eInternalContainer, eIsProxy, eProperties, eSetClass, eSetDeliver, eSetProxyURI`

Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicRemoveFromContainerFeature, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainerAdapterArray, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eContents, eCrossReferences, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDirectResource, eDynamicBasicRemoveFromContainer, eDynamicClass, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eHasSettings, eInternalResource, eInverseAdd, eInverseAdd, eInverseRemove, eIsSet, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eProxyURI, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetDirectResource, eSetResource, eSetStore, eSetting, eSettingDelegate, eSettings, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStore, eUnset, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

Methods inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl
`eBasicAdapterArray, eBasicHasAdapters`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eSetDeliver`

Field Detail

### ELEMENT_EDEFAULT

    protected static final org.w3c.dom.Element ELEMENT_EDEFAULT

  The default value of the '`Element`' attribute.

  See Also:
    `getElement()`

### element

    protected org.w3c.dom.Element element

  The cached value of the '`Element`' attribute.

  See Also:
    `getElement()`

### diagnostics

    protected EList<XSDDiagnostic> diagnostics

  The cached value of the '`Diagnostics`' containment reference list.

  See Also:
    `getDiagnostics()`

### FATAL

    protected static final int FATAL

See Also:
  Constant Field Values

### ERROR

    protected static final int ERROR

See Also:
  Constant Field Values

### WARNING

    protected static final int WARNING

See Also:
  Constant Field Values

### INFORMATION

    protected static final int INFORMATION

See Also:
  Constant Field Values

### updatingDOM

    protected boolean updatingDOM

### isReconciling

    protected boolean isReconciling

### forceResolve

    protected boolean forceResolve

### xsdContents

    protected EList<XSDConcreteComponent> xsdContents

### UNANALYZED

    protected final int UNANALYZED

See Also:
  Constant Field Values

### ANALYZING

    protected final int ANALYZING

See Also:
  Constant Field Values

### ANALYZED

    protected final int ANALYZED

See Also:
  Constant Field Values

### CIRCULAR

    protected final int CIRCULAR

See Also:
  Constant Field Values

Constructor Detail

### XSDConcreteComponentImpl

    protected XSDConcreteComponentImpl()

Method Detail

### eStaticClass

    protected EClass eStaticClass()

  Overrides:
    `eStaticClass` in class `EObjectImpl`

### getXSDFactory

    protected XSDFactory getXSDFactory()

### getXSDPackage

    protected XSDPackage getXSDPackage()

### getXSDContents

    public EList<XSDConcreteComponent> getXSDContents()

### getXSDConcreteComponentImpls

    protected EList<XSDConcreteComponentImpl> getXSDConcreteComponentImpls()

### reset

    public void reset()

### createElement

    protected final org.w3c.dom.Element createElement(int nodeType)

### createElement

    public org.w3c.dom.Element createElement()

### updateElement

    public void updateElement(boolean deep)

  Description copied from interface: `XSDConcreteComponent`
  Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization. For `deep == true`, or when ``getElement()` == null`, this does the same thing as `XSDConcreteComponent.updateElement()`; otherwise, it updates just the DOM element associated with this component to reflect the current state.

  Specified by:
    `updateElement` in interface `XSDConcreteComponent`
  See Also:
    `XSDConcreteComponent.updateElement()`, `XSDConcreteComponent.getElement()`

### updateElement

    public void updateElement()

  Description copied from interface: `XSDConcreteComponent`
  Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.

  Specified by:
    `updateElement` in interface `XSDConcreteComponent`
  See Also:
    `XSDConcreteComponent.updateElement(boolean)`, `XSDConcreteComponent.getElement()`

### updatePrefix

    protected void updatePrefix(org.w3c.dom.Node node,
                                java.lang.String namespace,
                                java.lang.String oldPrefix,
                                java.lang.String newPrefix)

### isUpdatingDOM

    protected boolean isUpdatingDOM()

### elementChanged

    public void elementChanged(org.w3c.dom.Element changedElement)

  Description copied from interface: `XSDConcreteComponent`
  Called to indicate that the given element has changed; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

  Specified by:
    `elementChanged` in interface `XSDConcreteComponent`

### elementAttributesChanged

    public void elementAttributesChanged(org.w3c.dom.Element changedElement)

  Description copied from interface: `XSDConcreteComponent`
  Called to indicate that the given element has changed attributes; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

  Specified by:
    `elementAttributesChanged` in interface `XSDConcreteComponent`

### elementContentsChanged

    public void elementContentsChanged(org.w3c.dom.Element changedElement)

  Description copied from interface: `XSDConcreteComponent`
  Called to indicate that the given element has changed contents; the element should typically be the same as the one returned `XSDConcreteComponent.getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

  Specified by:
    `elementContentsChanged` in interface `XSDConcreteComponent`

### traverseToRootForPatching

    protected void traverseToRootForPatching()

### traverseToRootForAnalysis

    protected void traverseToRootForAnalysis()

### patch

    protected void patch()

### analyze

    protected boolean analyze()

### validate

    public void validate()

  Description copied from interface: `XSDConcreteComponent`
  Validates whether this component conforms to the constraints defined in the XML Schema standard. `Diagnostics` are produced to report any problems. The effect of calling this for a component not directly or indirectly contained by a `schema` is undefined, and is likely to result in null pointer exceptions.

  Specified by:
    `validate` in interface `XSDConcreteComponent`
  See Also:
    `XSDConcreteComponent.getDiagnostics()`, `XSDConcreteComponent.clearDiagnostics()`

### clearDiagnostics

    public void clearDiagnostics()

  Description copied from interface: `XSDConcreteComponent`
  Clears any `diagnostics` associated with the component and all those it contains.

  Specified by:
    `clearDiagnostics` in interface `XSDConcreteComponent`
  See Also:
    `XSDConcreteComponent.validate()`, `XSDConcreteComponent.getDiagnostics()`

### reportConstraintViolation

    protected XSDDiagnostic reportConstraintViolation(java.lang.String part,
                                                      java.lang.String anchor,
                                                      org.w3c.dom.Element element,
                                                      java.lang.String attributeName,
                                                      java.lang.Object[] substitutions)

### checkElementComplexContent

    protected XSDDiagnostic checkElementComplexContent(java.lang.String elementName,
                                                       java.lang.String part,
                                                       java.lang.String anchor,
                                                       org.w3c.dom.Element element)

### printDFA

    protected void printDFA(XSDParticle.DFA dfa)

### checkComplexContent

    protected XSDDiagnostic checkComplexContent(java.lang.String builtInTypeName,
                                                java.lang.String part,
                                                java.lang.String anchor,
                                                org.w3c.dom.Element element)

### checkComplexContent

    protected XSDDiagnostic checkComplexContent(XSDComplexTypeDefinition xsdComplexTypeDefinition,
                                                java.lang.String part,
                                                java.lang.String anchor,
                                                org.w3c.dom.Element element)

### checkAttributeTypeConstraint

    protected XSDDiagnostic checkAttributeTypeConstraint(java.lang.String builtInTypeName,
                                                         java.lang.String builtInAttributeName,
                                                         java.lang.String value,
                                                         java.lang.String part,
                                                         java.lang.String anchor,
                                                         org.w3c.dom.Element element,
                                                         java.lang.String attributeName,
                                                         boolean isRequired)

### checkAttributeTypeConstraint

    protected XSDDiagnostic checkAttributeTypeConstraint(XSDComplexTypeDefinition xsdComplexTypeDefinition,
                                                         java.lang.String builtInAttributeName,
                                                         java.lang.String value,
                                                         java.lang.String part,
                                                         java.lang.String anchor,
                                                         org.w3c.dom.Element element,
                                                         java.lang.String attributeName,
                                                         boolean isRequired)

### checkBuiltInTypeConstraint

    protected XSDDiagnostic checkBuiltInTypeConstraint(java.lang.String builtInTypeName,
                                                       java.lang.String value,
                                                       java.lang.String part,
                                                       java.lang.String anchor,
                                                       org.w3c.dom.Element element,
                                                       java.lang.String attributeName,
                                                       boolean isRequired)

### checkSimpleTypeConstraint

    protected XSDDiagnostic checkSimpleTypeConstraint(XSDSimpleTypeDefinition xsdTypeDefinition,
                                                      java.lang.String value,
                                                      java.lang.String part,
                                                      java.lang.String anchor,
                                                      org.w3c.dom.Element element,
                                                      java.lang.String attributeName,
                                                      boolean isRequired)

### checkAttributes

    protected java.util.Collection<XSDDiagnostic> checkAttributes(java.lang.String part,
                                                                  java.lang.String anchor,
                                                                  org.w3c.dom.Element element,
                                                                  java.lang.String[] allowedAttributeNames)

### createRequiredAttributeDiagnostic

    protected XSDDiagnostic createRequiredAttributeDiagnostic(java.lang.String part,
                                                              java.lang.String anchor,
                                                              org.w3c.dom.Element element,
                                                              java.lang.String attributeName)

### getDiagnosticTarget

    protected XSDConcreteComponentImpl getDiagnosticTarget(XSDConcreteComponent xsdConcreteComponent)

### createDiagnostic

    protected XSDDiagnostic createDiagnostic(XSDDiagnosticSeverity severity,
                                             java.lang.String key)

### createDiagnostic

    protected XSDDiagnostic createDiagnostic(XSDDiagnosticSeverity severity,
                                             java.lang.String key,
                                             java.lang.Object s1)

### createDiagnostic

    protected XSDDiagnostic createDiagnostic(XSDDiagnosticSeverity severity,
                                             java.lang.String key,
                                             java.lang.Object s1,
                                             java.lang.Object s2)

### createDiagnostic

    protected XSDDiagnostic createDiagnostic(XSDDiagnosticSeverity severity,
                                             java.lang.String key,
                                             java.lang.Object s1,
                                             java.lang.Object s2,
                                             java.lang.Object s3)

### populateDiagnostic

    protected static java.lang.String populateDiagnostic(XSDDiagnostic xsdDiagnostic,
                                                         java.lang.String key,
                                                         java.lang.Object[] substitutions)

### reconcile

    protected void reconcile(org.w3c.dom.Element changedElement)

### reconcileAttributes

    protected void reconcileAttributes(org.w3c.dom.Element changedElement)

### getContentNodes

    protected java.util.Collection<org.w3c.dom.Element> getContentNodes(org.w3c.dom.Element changedElement)

### reconcileContents

    protected void reconcileContents(org.w3c.dom.Element changedElement)

### handleUnreconciledElement

    protected void handleUnreconciledElement(org.w3c.dom.Element child,
                                             java.util.List<XSDConcreteComponent> newContents,
                                             java.util.List<XSDConcreteComponent> remainingContents)

### handleReconciliation

    protected void handleReconciliation(java.util.List<XSDConcreteComponent> newContents,
                                        java.util.List<XSDConcreteComponent> remainingContents)

### handleAnnotationReconciliation

    protected void handleAnnotationReconciliation(EReference eReference,
                                                  java.util.List<XSDConcreteComponent> newContents,
                                                  java.util.List<XSDConcreteComponent> remainingContents)

### eNotify

    public void eNotify(Notification msg)

  Specified by:
    `eNotify` in interface `Notifier`
  Overrides:
    `eNotify` in class `BasicNotifierImpl`

### changeAttribute

    protected void changeAttribute(EAttribute eAttribute)

### changeReference

    protected void changeReference(EReference eReference)

### getAdoptionParentNode

    protected org.w3c.dom.Node getAdoptionParentNode(EReference eReference)

### handleElementForAdopt

    protected void handleElementForAdopt(EReference eReference,
                                         XSDConcreteComponent xsdConcreteComponent)

### adoptContent

    protected void adoptContent(EReference eReference,
                                XSDConcreteComponent xsdConcreteComponent)

### adoptBy

    protected void adoptBy(XSDSchema xsdSchema)

### adoptDiagnostic

    protected void adoptDiagnostic(XSDDiagnostic xsdDiagnostic)

### orphanContent

    protected void orphanContent(EReference eReference,
                                 XSDConcreteComponent xsdConcreteComponent)

### orphanBy

    protected void orphanBy(XSDSchema xsdSchema)

### orphanDiagnostic

    protected void orphanDiagnostic(XSDDiagnostic xsdDiagnostic)

### moveContent

    public void moveContent(EReference eReference,
                            XSDConcreteComponent xsdConcreteComponent)

### niceInsertBefore

    public void niceInsertBefore(org.w3c.dom.Node parent,
                                 org.w3c.dom.Node newChild,
                                 org.w3c.dom.Node referenceChild)

### forceNiceInsertBefore

    public void forceNiceInsertBefore(org.w3c.dom.Node parent,
                                      org.w3c.dom.Node newChild,
                                      org.w3c.dom.Node referenceChild)

### niceRemoveChild

    public void niceRemoveChild(org.w3c.dom.Node parent,
                                org.w3c.dom.Node child)

### forceNiceRemoveChild

    public void forceNiceRemoveChild(org.w3c.dom.Node parent,
                                     org.w3c.dom.Node child)

### forceReplace

    public void forceReplace(org.w3c.dom.Element replacementElement,
                             org.w3c.dom.Element referenceElement)

### forceEngulf

    public void forceEngulf(org.w3c.dom.Element newElement,
                            org.w3c.dom.Element engulfingElement,
                            org.w3c.dom.Element referenceElement,
                            org.w3c.dom.Node referenceChild)

### forceEngulf

    public void forceEngulf(org.w3c.dom.Node firstAdoptee,
                            org.w3c.dom.Element engulfingElement,
                            org.w3c.dom.Node referenceChild)

### niceSetAttribute

    protected void niceSetAttribute(org.w3c.dom.Element element,
                                    java.lang.String attribute,
                                    java.lang.String value)

### niceCreateNamespaceAttribute

    protected java.lang.String niceCreateNamespaceAttribute(java.lang.String namespace)

### niceSetAttributeURIValue

    protected void niceSetAttributeURIValue(org.w3c.dom.Element element,
                                            java.lang.String attribute,
                                            java.lang.String uriList)

### getContainer

    public XSDConcreteComponent getContainer()

  Description copied from interface: `XSDConcreteComponent`
  Returns the value of the 'Container' reference.

  This represents the concrete container of this component, i.e., the inverse of the black diamond relations in the UML model.

  Specified by:
    `getContainer` in interface `XSDConcreteComponent`
  Returns:
    the value of the 'Container' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Container()`

### getRootContainer

    public XSDConcreteComponent getRootContainer()

  Description copied from interface: `XSDConcreteComponent`
  Returns the value of the 'Root Container' reference.

  This walks the `containers` until it hits one that has no container.

  Specified by:
    `getRootContainer` in interface `XSDConcreteComponent`
  Returns:
    the value of the 'Root Container' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_RootContainer()`

### contains

    public boolean contains(XSDConcreteComponent xsdConcreteComponent)

  Description copied from interface: `XSDConcreteComponent`
  Returns whether the given component is contained by this component.

  Specified by:
    `contains` in interface `XSDConcreteComponent`
  Parameters:
    `xsdConcreteComponent` - a component.
  Returns:
    whether the component is contained by this component.

### getSchema

    public XSDSchema getSchema()

  Description copied from interface: `XSDConcreteComponent`
  Returns the value of the 'Schema' reference.

  This walks the `containers` until it reaches a schema.

  Specified by:
    `getSchema` in interface `XSDConcreteComponent`
  Returns:
    the value of the 'Schema' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Schema()`

### getDiagnostics

    public EList<XSDDiagnostic> getDiagnostics()

  Specified by:
    `getDiagnostics` in interface `XSDConcreteComponent`
  Returns:
    the value of the 'Diagnostics' containment reference list.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Diagnostics()`

### eInverseRemove

    public NotificationChain eInverseRemove(InternalEObject otherEnd,
                                            int featureID,
                                            NotificationChain msgs)

  Overrides:
    `eInverseRemove` in class `BasicEObjectImpl`

### eGet

    public java.lang.Object eGet(int featureID,
                                 boolean resolve,
                                 boolean coreType)

  Specified by:
    `eGet` in interface `InternalEObject`
  Overrides:
    `eGet` in class `BasicEObjectImpl`

### eSet

    public void eSet(int featureID,
                     java.lang.Object newValue)

  Specified by:
    `eSet` in interface `InternalEObject`
  Overrides:
    `eSet` in class `BasicEObjectImpl`

### eUnset

    public void eUnset(int featureID)

  Specified by:
    `eUnset` in interface `InternalEObject`
  Overrides:
    `eUnset` in class `BasicEObjectImpl`

### eIsSet

    public boolean eIsSet(int featureID)

  Specified by:
    `eIsSet` in interface `InternalEObject`
  Overrides:
    `eIsSet` in class `BasicEObjectImpl`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `BasicEObjectImpl`

### getBestConcreteComponent

    public XSDConcreteComponent getBestConcreteComponent(java.util.List<org.w3c.dom.Element> elementPath)

### considerAllContainsForBestConcreteComponent

    protected boolean considerAllContainsForBestConcreteComponent()

### setListContentAndOrder

    public static <T> void setListContentAndOrder(EList<T> targetList,
                                                  java.util.List<? extends T> prototypeList)

### getURIReferenceLabel

    protected java.lang.String getURIReferenceLabel()

### eURIFragmentSegment

    public java.lang.String eURIFragmentSegment(EStructuralFeature eStructuralFeature,
                                                EObject eObject)

  Specified by:
    `eURIFragmentSegment` in interface `InternalEObject`
  Overrides:
    `eURIFragmentSegment` in class `BasicEObjectImpl`

### eObjectForURIFragmentSegment

    public EObject eObjectForURIFragmentSegment(java.lang.String uriFragmentSegment)

  Specified by:
    `eObjectForURIFragmentSegment` in interface `InternalEObject`
  Overrides:
    `eObjectForURIFragmentSegment` in class `BasicEObjectImpl`

### resolveTypeDefinitionURI

    public XSDTypeDefinition resolveTypeDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveTypeDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `XSDConcreteComponent.resolveTypeDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveTypeDefinition

    public XSDTypeDefinition resolveTypeDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveTypeDefinition

    public XSDTypeDefinition resolveTypeDefinition(java.lang.String namespace,
                                                   java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `XSDConcreteComponent.resolveTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedTypeDefinition

    protected XSDTypeDefinition createUnresolvedTypeDefinition(java.lang.String namespace,
                                                               java.lang.String localName)

### resolveSimpleTypeDefinitionURI

    public XSDSimpleTypeDefinition resolveSimpleTypeDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved simple type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveSimpleTypeDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `XSDConcreteComponent.resolveSimpleTypeDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveSimpleTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveSimpleTypeDefinition

    public XSDSimpleTypeDefinition resolveSimpleTypeDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved simple type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveSimpleTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveSimpleTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveSimpleTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveSimpleTypeDefinition

    public XSDSimpleTypeDefinition resolveSimpleTypeDefinition(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved simple type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveSimpleTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `XSDConcreteComponent.resolveSimpleTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveSimpleTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedSimpleTypeDefinition

    protected XSDSimpleTypeDefinition createUnresolvedSimpleTypeDefinition(java.lang.String namespace,
                                                                           java.lang.String localName)

### resolveComplexTypeDefinitionURI

    public XSDComplexTypeDefinition resolveComplexTypeDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved complex type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveComplexTypeDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `XSDConcreteComponent.resolveComplexTypeDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveComplexTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveComplexTypeDefinition

    public XSDComplexTypeDefinition resolveComplexTypeDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved complex type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveComplexTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveComplexTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveComplexTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveComplexTypeDefinition

    public XSDComplexTypeDefinition resolveComplexTypeDefinition(java.lang.String namespace,
                                                                 java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved complex type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveComplexTypeDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `XSDConcreteComponent.resolveComplexTypeDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveComplexTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedComplexTypeDefinition

    protected XSDComplexTypeDefinition createUnresolvedComplexTypeDefinition(java.lang.String namespace,
                                                                             java.lang.String localName)

### resolveAttributeDeclarationURI

    public XSDAttributeDeclaration resolveAttributeDeclarationURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeDeclarationURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `XSDConcreteComponent.resolveAttributeDeclaration(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveAttributeDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveAttributeDeclaration

    public XSDAttributeDeclaration resolveAttributeDeclaration(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute declaration of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveAttributeDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveAttributeDeclaration

    public XSDAttributeDeclaration resolveAttributeDeclaration(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `XSDConcreteComponent.resolveAttributeDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedAttributeDeclaration

    protected XSDAttributeDeclaration createUnresolvedAttributeDeclaration(java.lang.String namespace,
                                                                           java.lang.String localName)

### resolveElementDeclarationURI

    public XSDElementDeclaration resolveElementDeclarationURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved element declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveElementDeclarationURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `XSDConcreteComponent.resolveElementDeclaration(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveElementDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveElementDeclaration

    public XSDElementDeclaration resolveElementDeclaration(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved element declaration of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveElementDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveElementDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveElementDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveElementDeclaration

    public XSDElementDeclaration resolveElementDeclaration(java.lang.String namespace,
                                                           java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved element declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveElementDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `XSDConcreteComponent.resolveElementDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveElementDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedElementDeclaration

    protected XSDElementDeclaration createUnresolvedElementDeclaration(java.lang.String namespace,
                                                                       java.lang.String localName)

### resolveAttributeGroupDefinitionURI

    public XSDAttributeGroupDefinition resolveAttributeGroupDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute group definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeGroupDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved attribute group definition.
  See Also:
    `XSDConcreteComponent.resolveAttributeGroupDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveAttributeGroupDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveAttributeGroupDefinition

    public XSDAttributeGroupDefinition resolveAttributeGroupDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute group definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeGroupDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved attribute group definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveAttributeGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeGroupDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveAttributeGroupDefinition

    public XSDAttributeGroupDefinition resolveAttributeGroupDefinition(java.lang.String namespace,
                                                                       java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved attribute group definition the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveAttributeGroupDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute group definition
  See Also:
    `XSDConcreteComponent.resolveAttributeGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveAttributeGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedAttributeGroupDefinition

    protected XSDAttributeGroupDefinition createUnresolvedAttributeGroupDefinition(java.lang.String namespace,
                                                                                   java.lang.String localName)

### resolveModelGroupDefinitionURI

    public XSDModelGroupDefinition resolveModelGroupDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved model group definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveModelGroupDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `XSDConcreteComponent.resolveModelGroupDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveModelGroupDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveModelGroupDefinition

    public XSDModelGroupDefinition resolveModelGroupDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved model group definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveModelGroupDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveModelGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveModelGroupDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveModelGroupDefinition

    public XSDModelGroupDefinition resolveModelGroupDefinition(java.lang.String namespace,
                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved model group definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveModelGroupDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `XSDConcreteComponent.resolveModelGroupDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveModelGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedModelGroupDefinition

    protected XSDModelGroupDefinition createUnresolvedModelGroupDefinition(java.lang.String namespace,
                                                                           java.lang.String localName)

### resolveIdentityConstraintDefinitionURI

    public XSDIdentityConstraintDefinition resolveIdentityConstraintDefinitionURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved identity constraint definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveIdentityConstraintDefinitionURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `XSDConcreteComponent.resolveIdentityConstraintDefinition(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveIdentityConstraintDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveIdentityConstraintDefinition

    public XSDIdentityConstraintDefinition resolveIdentityConstraintDefinition(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved identity constraint definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveIdentityConstraintDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveIdentityConstraintDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveIdentityConstraintDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveIdentityConstraintDefinition

    public XSDIdentityConstraintDefinition resolveIdentityConstraintDefinition(java.lang.String namespace,
                                                                               java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved identity constraint definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveIdentityConstraintDefinition` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `XSDConcreteComponent.resolveIdentityConstraintDefinitionURI(java.lang.String)`, `XSDConcreteComponent.resolveIdentityConstraintDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedIdentityConstraintDefinition

    protected XSDIdentityConstraintDefinition createUnresolvedIdentityConstraintDefinition(java.lang.String namespace,
                                                                                           java.lang.String localName)

### resolveNotationDeclarationURI

    public XSDNotationDeclaration resolveNotationDeclarationURI(java.lang.String uri)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved notation declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveNotationDeclarationURI` in interface `XSDConcreteComponent`
  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved notation declaration.
  See Also:
    `XSDConcreteComponent.resolveNotationDeclaration(java.lang.String, java.lang.String)`, `XSDConcreteComponent.resolveNotationDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveNotationDeclaration

    public XSDNotationDeclaration resolveNotationDeclaration(java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved notation declaration the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveNotationDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved notation declaration
  See Also:
    `XSDConcreteComponent.getSchema()`, `XSDSchema.getTargetNamespace()`, `XSDConcreteComponent.resolveNotationDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveNotationDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveNotationDeclaration

    public XSDNotationDeclaration resolveNotationDeclaration(java.lang.String namespace,
                                                             java.lang.String localName)

  Description copied from interface: `XSDConcreteComponent`
  Returns the resolved notation declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Specified by:
    `resolveNotationDeclaration` in interface `XSDConcreteComponent`
  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved notation declaration.
  See Also:
    `XSDConcreteComponent.resolveNotationDeclarationURI(java.lang.String)`, `XSDConcreteComponent.resolveNotationDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### createUnresolvedNotationDeclaration

    protected XSDNotationDeclaration createUnresolvedNotationDeclaration(java.lang.String namespace,
                                                                         java.lang.String localName)

### getComponentsWithApplicationInformation

    public java.util.Collection<XSDConcreteComponent> getComponentsWithApplicationInformation(java.lang.String sourceURI)

  Description copied from interface: `XSDConcreteComponent`
  Returns the collection of components that have an `annotation` containing an `appinfo` with given source URI.

  Specified by:
    `getComponentsWithApplicationInformation` in interface `XSDConcreteComponent`
  Parameters:
    `sourceURI` - the source URI to match.
  Returns:
    the collection of matching components.
  See Also:
    `XSDAnnotation.getApplicationInformationSources()`

### getComponentsWithUserInformation

    public java.util.Collection<XSDConcreteComponent> getComponentsWithUserInformation(java.lang.String sourceURI)

  Description copied from interface: `XSDConcreteComponent`
  Returns the collection of components that have an `annotation` containing a `documentation` with given source URI.

  Specified by:
    `getComponentsWithUserInformation` in interface `XSDConcreteComponent`
  Parameters:
    `sourceURI` - the source URI to match.
  Returns:
    the collection of matching components.
  See Also:
    `XSDAnnotation.getApplicationInformationSources()`

### getComponentsWithInformation

    protected void getComponentsWithInformation(java.util.Collection<XSDConcreteComponent> result,
                                                int nodeType,
                                                java.lang.String sourceURI)

### getElement

    public org.w3c.dom.Element getElement()

  Specified by:
    `getElement` in interface `XSDConcreteComponent`
  Returns:
    the value of the 'Element' attribute.
  See Also:
    `XSDConcreteComponent.setElement(Element)`, `XSDPackage.getXSDConcreteComponent_Element()`

### setElementGen

    public void setElementGen(org.w3c.dom.Element newElement)

### setElement

    public void setElement(org.w3c.dom.Element element)

  Description copied from interface: `XSDConcreteComponent`
  Sets the value of the '`Element`' attribute.

  Specified by:
    `setElement` in interface `XSDConcreteComponent`
  Parameters:
    `element` - the new value of the 'Element' attribute.
  See Also:
    `XSDConcreteComponent.getElement()`

### cloneConcreteComponent

    public XSDConcreteComponent cloneConcreteComponent(boolean deep,
                                                       boolean shareDOM)

  Description copied from interface: `XSDConcreteComponent`
  Creates a clone of the component. The clone may be deep and may share the DOM of this component.

  Specified by:
    `cloneConcreteComponent` in interface `XSDConcreteComponent`
  Parameters:
    `deep` - whether the clone should be deep.
    `shareDOM` - whether the clone should share the original DOM
  Returns:
    a clone of the component.

### cloneConcreteComponents

    protected static <T extends XSDConcreteComponent> java.util.List<T> cloneConcreteComponents(java.util.List<T> xsdConcreteComponents,
                                                                                                boolean deep,
                                                                                                boolean shareDOM)

### eNotificationRequired

    public boolean eNotificationRequired()

  Specified by:
    `eNotificationRequired` in interface `InternalEObject`
  Overrides:
    `eNotificationRequired` in class `BasicNotifierImpl`

### convertToBoolean

    protected boolean convertToBoolean(java.lang.String value)

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.